#include <iostream>
using namespace std;

int prebrojKaraktere(char *matrica, int visina, int sirina, char cilj) {
    int ukupanBroj = 0;
    for (int red = 0; red < visina; red++) {
        for (int kol = 0; kol < sirina; kol++) {
            if (*(matrica + red * sirina + kol) == cilj) {
                ukupanBroj++;
            }
        }
    }
    return ukupanBroj;
}

bool prosiriMatricu(char *matrica, int visina, int sirina, char aktivni, char neaktivni) {
    bool promenjeno = false;

    for (int red = 0; red < visina; red++) {
        for (int kol = 0; kol < sirina; kol++) {
            if (*(matrica + red * sirina + kol) == aktivni) {
                if (kol > 0 && *(matrica + red * sirina + (kol - 1)) != '*' &&
                    *(matrica + red * sirina + (kol - 1)) != aktivni &&
                    *(matrica + red * sirina + (kol - 1)) != neaktivni) {
                    *(matrica + red * sirina + (kol - 1)) = 'A';
                    promenjeno = true;
                }
                if (kol < sirina - 1 && *(matrica + red * sirina + (kol + 1)) != '*' &&
                    *(matrica + red * sirina + (kol + 1)) != aktivni &&
                    *(matrica + red * sirina + (kol + 1)) != neaktivni) {
                    *(matrica + red * sirina + (kol + 1)) = 'A';
                    promenjeno = true;
                }
                if (red > 0 && *(matrica + (red - 1) * sirina + kol) != '*' &&
                    *(matrica + (red - 1) * sirina + kol) != aktivni &&
                    *(matrica + (red - 1) * sirina + kol) != neaktivni) {
                    *(matrica + (red - 1) * sirina + kol) = 'A';
                    promenjeno = true;
                }
                if (red < visina - 1 && *(matrica + (red + 1) * sirina + kol) != '*' &&
                    *(matrica + (red + 1) * sirina + kol) != aktivni &&
                    *(matrica + (red + 1) * sirina + kol) != neaktivni) {
                    *(matrica + (red + 1) * sirina + kol) = 'A';
                    promenjeno = true;
                }
            }
        }
    }

    for (int red = 0; red < visina; red++) {
        for (int kol = 0; kol < sirina; kol++) {
            if (*(matrica + red * sirina + kol) == 'A') {
                *(matrica + red * sirina + kol) = aktivni;
            }
        }
    }

    return promenjeno;
}

int main() {
    int visina, sirina;
    cin >> visina >> sirina;

    char mreza[visina][sirina];

    for (int red = 0; red < visina; red++) {
        for (int kol = 0; kol < sirina; kol++) {
            cin >> mreza[red][kol];
        }
    }

    prosiriMatricu(&mreza[0][0], visina, sirina, 'X', 'S');
    while (prosiriMatricu(&mreza[0][0], visina, sirina, 'S', 'X')) {
       prosiriMatricu(&mreza[0][0], visina, sirina, 'X', 'S');
    }

    cout << prebrojKaraktere(&mreza[0][0], visina, sirina, 'S') << endl;

    return 0;
}